package com.huiju.foyo.filter;

import com.huiju.foyo.model.SysUser;
import com.huiju.foyo.session.SessionLoad;
import com.huiju.foyo.session.UserControl;
import org.springframework.stereotype.Component;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@Component
public class FoyoFilter implements Filter {

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        HttpServletRequest request = (HttpServletRequest) servletRequest;
        HttpServletResponse response = (HttpServletResponse) servletResponse;

        if (request.getRequestURI().equals("/admin/login")) {
            filterChain.doFilter(servletRequest, servletResponse);
            return;
        }

        SysUser user = SessionLoad.getUser();
        if (null == user) {
            user = (SysUser) request.getSession().getAttribute(UserControl.SESSION_USER);
            if (null == user) {
                // 重定向登录
                request.getRequestDispatcher("/admin/toLogin").forward(servletRequest, servletResponse);
                return;
            }
        }

        // 设置用户
        UserControl.setUser(user);

        // 继续执行
        filterChain.doFilter(servletRequest, servletResponse);
    }
}
